
/* 
 * Title       : ds1820.c
 * Description : DS1820 subroutine
 * Author      : KAWAMOTO Yasuhisa
 * URL         : http://www.devdrv.co.jp/
 * Date        : 01/16/2006
 */
 
//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <c8051f330.h>
#include "main.h"

//-----------------------------------------------------------------------------
// init_ds1820
//-----------------------------------------------------------------------------
void init_ds1820(void)
{
}

//-----------------------------------------------------------------------------
// ds1820
//-----------------------------------------------------------------------------
void ds1820(void)
{
	unsigned char i;
	
	for(i = 0; i < 8; i++)
		uart0_put_val(ROMCode[i]);
	
	// Convert T
	OWTouchReset();
	OWWriteByte(0x55);
	for(i = 0; i < 8; i++)
		OWWriteByte(ROMCode[i]);
	OWWriteByte(0x44);
	
	for(i = 0; i < 75; i++)						// tCONV = 750ms
		tickDelay(10000*(SYSCLK/100000)/140);
	
	// Read Scratchpad
	OWTouchReset();
	OWWriteByte(0x55);
	for(i = 0; i < 8; i++)
		OWWriteByte(ROMCode[i]);
	OWWriteByte(0xBE);
	for(i = 0; i < 9; i++)
	{
		uart0_put_val(OWReadByte());
	}
	
	uart0_put_char('\r');
	uart0_put_char('\n');
}
