
/* 
 * Title       : main.h
 * Author      : KAWAMOTO Yasuhisa
 * URL         : http://www.devdrv.co.jp/
 * Date        : 01/12/2006
 */

#ifndef __MAIN_H
#define __MAIN_H

//-----------------------------------------------------------------------------
#define FALSE 0
#define TRUE  1
//#define DEBUG 1
#undef DEBUG

//-----------------------------------------------------------------------------
#define SYSCLK     24500000
#define BAUDRATE   9600
#define TIMER2RATE 20
#define ROUNDRATE  1000

#define OWN_DRIVE   P0_0=1;P2_0=0
#define OWN_RELEASE P0_0=0;P2_0=1
#define OWN_SENSE   P0_1
#define CTS         P0_2
#define DCD         P0_3
#define RTS         P0_7

//-----------------------------------------------------------------------------
extern unsigned char ROMCode[8];
extern unsigned char ScratchPAD[9];
extern unsigned char LastDeviceFlag;
extern volatile unsigned char tmr2_count;

//-----------------------------------------------------------------------------
void init_f330(void);
void uart0_put_char(char);
void uart0_put_val(unsigned char);
void timer2_isr(void) interrupt 5;

void tickDelay(unsigned short);
unsigned char OWTouchReset(void);
unsigned char OWTouchBit(unsigned char);
void OWWriteBit(unsigned char);
unsigned char OWReadBit(void);
void OWWriteByte(unsigned char);
unsigned char OWReadByte(void);
unsigned char OWFirst(void);
unsigned char OWNext(void);

void init_ds1820(void);
void ds1820(void);

void init_ds1822(void);
void ds1822(void);

void init_ds2438(void);
void ds2438(void);

#endif
